
'********** Zasilacz z odczytem napicia wyjciowego i prdu ********

'**********                   nowak_mariusz@op.pl                              *********
'************                    Nowak Mariusz                                  **********
'**************                    Gacki 23/4                                   ************
'****************           28-400 Piczw                          **************


'                                       konfiguracja procesora
'*********************************************************

$crystal = 4000000                                                                                  'informuje kompilator o wielkoci rezonatora kwarcowego

$eeprom                                                                                             'dane w lini data bd umieszczone w pamici eeprom
Data 192 , 249 , 164 , 176 , 153 , 146 , 130 , 248 , 128 , 144 , 255                                'tabela cyfr

Config Portb = Output : Portb = 255                                                                 'konfiguracja
Config Portd = 120 : Portd = 127                                                                    'portw

Config Scl = Portd.5                                                                                'konfiguracja linii SCL magistrali I2C
Config Sda = Portd.6                                                                                'konfiguracja linii SDA magistrali I2C

Config Timer0 = Timer , Prescale = 64                                                               'konfiguracja timer0
Enable Interrupts                                                                                   'odblokowanie globalnych przerwa
Enable Timer0                                                                                       'odblokowanie przerwania timer0
On Timer0 Co4ms                                                                                     'procedura obsugi przerwania

'                                      deklaracje zmiennych
'*********************************************************

Dim Licznik As Eram Byte At 11                                                                      'zmienna umieszczona w pamici eeprom przechowujca warto nastawionego napicia
Dim Odczyt As Byte                                                                                  'zmienna zawierajaca odczytana liczbe
Dim Zapis As Byte                                                                                   'zmienna zawierajaca liczbe do zapisu
Dim Jednostki As Byte , Dziesiatki As Byte , Setki As Byte                                          'zmienne okrelajce cyfry na poszczeglnych wywietlaczach
Dim Wyswietlacz As Byte                                                                             'zmienna wykorzystywana do multipleksowania wywietlacza
Dim A As Byte                                                                                       'zmienna pomocnicza przy konwersji pomiaru
Dim Przyciski As Byte                                                                               'zmienna przechowujca stan przyciskw
Dim Zero As Byte                                                                                    'zmienna pomocnicza
Dim Uniwers As Byte                                                                                 'zmienna pomocnicza
Dim Maxi As Byte                                                                                    'zmienna pomocnicza
Dim Wpis As Bit                                                                                     'zmienna pomocnicza
Dim Prad As Bit                                                                                     'zmienna pomocnicza, okrelajca pomiar prdu

'                                      deklaracje procedur
'*********************************************************

Declare Sub Wpisz
Declare Sub Odczytaj
Declare Sub Konwertuj_pomiar
Declare Sub Wyswietl

'                                   ustawienia pocztkowe
'*********************************************************

Prad = 0                                                                                            'standartowo - pomiar napicia
Maxi = 60
Uniwers = 4
Zero = 192                                                                                          'odnowienie zawartoci
Writeeeprom Zero , 0                                                                                'komrki  0 pamici eeprom
Zapis = Licznik                                                                                     'odczytanie z pamici ostatnich nastaw napicia wyjciowego

'                                    program gwny
'*********************************************************

Do                                                                                                  'gwna ptla programu
Loop                                                                                                'koniec ptli
End                                                                                                 'koniec programu

Sub Konwertuj_pomiar                                                                                'procedura konwersji pomiaru
   A = Odczyt                                                                                       'wpisanie wyniku pomiaru do zmiennej pomocnieczej
   If A < 100 Then                                                                                  'jeeli wartoc mniejsza od 100, to
      If Prad = 0 Then Setki = 10 Else Setki = 0                                                    'jeeli pomiar napiecia, to wyga zero z lewej strony
   Else                                                                                             'w przeciwnym wypadku
      A = A - 100                                                                                   'zmniejsz wartoc pomiaru o 100
      If A < 100 Then                                                                               'jeeli wartoc pomiaru mniejsza jest od 100,to
         Setki = 1                                                                                  'do zmiennej setki wpisz wartoc 1
      Else                                                                                          'w przeciwnym wypadku
         Setki = 2                                                                                  'do zmiennej setki wpisz wartoc 2
         A = A - 100                                                                                'i zmniejsz wynik pomiaru o kolejne 100
      End If                                                                                        'koniec warunku
   End If                                                                                           'koniec warunku
   A = Makebcd(a)                                                                                   'konwertuj pomiar do formatu BCD
   Jednostki = A And 15                                                                             'oblicz jednostki
   Dziesiatki = A                                                                                   'oblicz
   Shift Dziesiatki , Right , 4                                                                     'dziesitki
End Sub                                                                                             'koniec procedury

Sub Wpisz                                                                                           'procedura regulujaca napicie wyjciowe
   Portb = 255                                                                                      'wygaszenie wywietlaczy na czas pomiaru
   I2cinit                                                                                          'inicjalizacja magistrali I2C
   I2cstart                                                                                         'generacja sygnau startu
   I2cwbyte 144                                                                                     'wysanie adresu do zapisu
   I2cwbyte 64                                                                                      'umozliwienie wpisu do PCF8591
   I2cwbyte Zapis                                                                                   'wysanie wartoci napicia wyjciowego
   I2cstop                                                                                          'koniec transmisji
   Config Portd = 120                                                                               'przywrcenie pind.5 i pind.6 jako wyjcia
End Sub                                                                                             'koniec procedury

Sub Odczytaj                                                                                        'procedura odczytujca napicia wejciowe
   Portb = 255                                                                                      'wygaszenie wywietlaczy na czas pomiaru
   I2cinit                                                                                          'inicjalizacja magistrali I2C
   I2cstart                                                                                         'generacja sygnau startu
   I2cwbyte 144                                                                                     'wysanie adresu do zapisu
   If Prad = 0 Then I2cwbyte 65                                                                     'jeeli wywietlane napicie, to odczytaj z wejcia I1
   If Prad = 1 Then I2cwbyte 67                                                                     'jezeli wywietlany prd, to odczytaj z wejcia I3
   I2cstop                                                                                          'koniec transmisji
   I2cstart                                                                                         'generacja sygnau startu
   I2cwbyte 145                                                                                     'wysanie adresu do odczytu
   I2crbyte Odczyt , Nack                                                                           'odczytanie wartosci przetwornika
   I2cstop                                                                                          'koniec transmisji
   Config Portd = 120                                                                               'przywrcenie pind.5 i pind.6 jako wyjcia
End Sub                                                                                             'koniec procedury

Sub Wyswietl
   Incr Wyswietlacz
   If Wyswietlacz = 4 Then Wyswietlacz = 0
   Portd = 127
   Select Case Wyswietlacz
      Case 0
         Readeeprom Portb , Jednostki
         Portd.3 = 0
      Case 1
         Readeeprom Portb , Dziesiatki
         Portd.4 = 0
         If Prad = 0 Then Portb.7 = 0                                                               'jezeli mierzone napicie, to zapal kropke
      Case 2
         Readeeprom Portb , Setki
         Portd.5 = 0
         If Prad = 1 Then Portb.7 = 0                                                               'jezeli mierzony prd, to zapal kropke
      Case 3
         Portd.6 = 0
         If Prad = 0 Then Portb = 227                                                               'zapalenie litery "u"
         If Prad = 1 Then Portb = 239                                                               'zapalenie litery "i"
   End Select
End Sub

Co4ms:
   Incr Zero
   If Zero = 0 Then
      Zero = 215
      Call Odczytaj
   End If
' Klasyczna obsuga "inteligentnych" przyciskw + EEPROM-Licznik + I2C
   Decr Uniwers
   If Uniwers = 0 Then
      Przyciski = Pind
      Przyciski = Przyciski And &B111
      Select Case Przyciski
         Case 3:
            Toggle Prad
         Case 5 :
            Maxi = Maxi - 8
            If Maxi < 8 Then Maxi = 8
            Uniwers = Maxi
            Wpis = 1
            Decr Zapis
            If Zapis = 255 Then Zapis = 0
         Case 6:
            Maxi = Maxi - 8
            If Maxi < 8 Then Maxi = 8
            Uniwers = Maxi
            Wpis = 1
            Incr Zapis
            If Zapis = 0 Then Zapis = 255
         Case Else :
            Uniwers = 4
            Maxi = 60
            If Wpis = 1 Then
               Wpis = 0
               Licznik = Zapis
            End If
      End Select
      Call Wpisz
   End If
   Call Konwertuj_pomiar
   Call Wyswietl
Return